import type { Particle } from "../Core/Particle";
import type { ICoordinates3d } from "../Core/Interfaces/ICoordinates";
import type { IDimension3d } from "../Core/Interfaces/IDimension";
import { Parallelepiped } from "./Parallelepiped";
import { Point3d } from "./Point3d";
import { Range3d } from "./Range3d";
export declare class OctTree {
    readonly parallelepiped: Parallelepiped;
    readonly capacity: number;
    readonly points: Point3d[];
    private northEastFront?;
    private northEastBack?;
    private northWestFront?;
    private northWestBack?;
    private southEastFront?;
    private southEastBack?;
    private southWestFront?;
    private southWestBack?;
    private divided;
    constructor(parallelepiped: Parallelepiped, capacity: number);
    subdivide(): void;
    insert(point: Point3d): boolean;
    queryCircle(position: ICoordinates3d, radius: number): Particle[];
    queryParallelepiped(position: ICoordinates3d, size: IDimension3d): Particle[];
    query(range: Range3d, found?: Particle[]): Particle[];
}
