import { OptionsColor } from "../OptionsColor";
import { ColorAnimation } from "./ColorAnimation";
export class AnimatableColor extends OptionsColor {
    constructor() {
        super();
        this.animation = new ColorAnimation();
    }
    static create(source, data) {
        const color = source !== null && source !== void 0 ? source : new AnimatableColor();
        if (data !== undefined) {
            color.load(typeof data === "string" ? { value: data } : data);
        }
        return color;
    }
    load(data) {
        super.load(data);
        this.animation.load(data === null || data === void 0 ? void 0 : data.animation);
    }
}
